:- module(path_probability,_).

:- use_package(tclp_aggregates).


:- table reach(_,sum).
:- table path(_,_,thr(0.001)).


reach(N,P) :- path(a,N,P).

path(X,Y,P) :-
	edge(X,Y,P).

path(X,Y,P) :-
	edge(X,Z,P1),
	path(Z,Y,P2),
	P is P1 * P2.

edge(a,b,0.2).
edge(a,c,0.3).
edge(c,c,0.2).
edge(c,d,0.8).
edge(a,e,0.0002).
edge(b,e,0.0003).


entails(sum,_,_) :- fail.
join(sum, A, B, C) :- C is A + B.

entails(thr(Theta), A, B):-
	A < Theta * B.
