:- discontiguous entails/3, join/4.

join(_,_,_,_) :- fail.
entails(_,_,V) :-  var(V), !.

:- use_package(tabling).
:- active_tclp.

:- use_package(attr).
:- use_module(engine(attributes)).


%%%%%%% attributes predicates %%%%%%%%%%%%%%%%%%%%
:- multifile attr_portray_hook/2.
:- multifile attr_unify_hook/2. %% needed
:- multifile attribute_goals/3.

attr_portray_hook(Att, Var) :-
	display(Var), display(', '), display(Att).

attr_unify_hook(_Att, _X) :-
	print(unify_hook),nl,
	true.

attribute_goals(X, [S|T], T) :-
	get_attr_local(X, Att),
	S = (abs(X, Att)).

put(Var,Att) :- put_attr_local(Var, Att).
get(Var,Att) :- get_attr_local(Var, Att).
del(Var) :- detach_attribute(Var).
%%%%%%% attributes predicates %%%%%%%%%%%%%%%%%%%%




%%%%%%% TCLP Interface %%%%%%%%%%%%%%%%%%%%
call_domain_projection([], []).
call_domain_projection([V|Vars], [A|Atts]) :-
	get(V,A),
	call_domain_projection(Vars, Atts).
call_entail(Atts1, Atts2) :-
	check_entail(Atts1, Atts2), !.
call_store_projection(_, Att, Att).

answer_domain_projection([], []).
answer_domain_projection([V|Vars], [A|Atts]) :-
	get(V,A),
	answer_domain_projection(Vars,Atts).
answer_check_entail(Atts1, Atts2 , 1) :-
	check_entail(Atts1, Atts2), !.
answer_check_entail(Atts1, Atts2 , -1) :-
	check_entail(Atts2, Atts1), !.
answer_check_entail(Atts1, Atts2, agg(AttsAgg)) :-
	check_aggregation(Atts1, Atts2, AttsAgg),!,
	print(agg(Atts1,Atts2,AttsAgg)),nl,nl.
	% (
	%     Atts2 = AttsAgg ->
	%     print(entail),nl,
	%     Result is 1
	% ;
	%     Result = agg(AttsAgg)
	% ).

answer_store_projection(_, St, St).

apply_answer([], []).
apply_answer([V|Vars], [A|Atts]) :-
	apply_answer_(V,A),
	apply_answer(Vars,Atts).

check_entail([],[]).
check_entail([A1|Att1],[A2|Att2]) :-
	check_entail_(A1,A2),
	check_entail(Att1, Att2).

%check_entail_( _             , (_, Var))        :- var(Var), !.
%check_entail_((_,Var)        , _)               :- var(Var), !, fail.
check_entail_((Aggregator,A1), (Aggregator,A2)) :-
	entails(Aggregator,A1,A2).
 
% a_check_entail([],[]).
% a_check_entail([A1|Att1],[A2|Att2]) :-
% 	a_check_entail_(A1,A2),
% 	a_check_entail(Att1, Att2).

% a_check_entail_( _, (_, Var)) :- var(Var), !.
% a_check_entail_((Aggregator,A1), (Aggregator,A2)) :-
% 	a_entails(Aggregator,A1,A2).
 

check_aggregation([],[],[]).
check_aggregation([A1|Att1], [A2|Att2], [Agg|AttAgg]) :-
	check_aggregation_(A1,A2,Agg),
	check_aggregation(Att1,Att2,AttAgg).

check_aggregation_((Agg,A1),(Agg,A2),(Agg,A3)) :-
	join(Agg,A1,A2,A3).

apply_answer_(V, (Aggregator,A)) :-
	get(V, (Aggregator,A1)),
	var(A1),
	A1 = A, !.
apply_answer_(V, (Aggregator,A)) :-
	get(V, (Aggregator,A1)),
	entails(Aggregator,A1,A).

%%%%%%% TCLP Interface %%%%%%%%%%%%%%%%%%%%

