:- module(game_prolog_01, _).

:- use_module(library(dynamic)).
:- dynamic fun/1.

total_fun(F) :-
	num_g(B),
	assert(fun(0)),
	(
	    reach(st(0,b,_,_), st(B,b,_,Fs)),
	    fun(F1),
	    F1 < Fs,
	    retractall(fun(_)),
	    assert(fun(Fs)),
	    fail
	;
	    fun(F)
	).

reach(A,B) :-
	edge(A,B).
reach(A,B) :-
	edge(A,Z),
	reach(Z,B).

edge(st(0, b, T, 0), st(1, a, T, 0)) :- 
	cap(T).
edge(st(Na, b, Ta, F), st(Nb, a, Tb, F)) :-
	num_g(TN),
	Na =< TN,
	Na > 0,
	Nb is Na + 1,
	refill(T),
	cap(TT),
	(
	    TT < Ta + T ->
	    Tb = TT
	;
	    Tb is Ta + T
	).
edge(st(Na, b, Ta, Fa), st(Na, b, Tb, Fb)) :-
	num_g(TN),
	Na =< TN,
	Na > 0,
	fun(Na, F),
	F > 0, % Repeat only if it gives fun
	Ta > 0,
	Tb is Ta - 1,
	Fb is Fa + F.	
edge(st(Na, a, Ta, Fa), st(Na, b, Tb, Fb)) :-
	num_g(TN),
	Na =< TN,
	Na > 0,
	fun(Na, F),
	Ta > 0,
	Tb is Ta - 1,
	Fb is Fa + F.	


:- include(data_01).

main(_) :-
	statistics(runtime, _),
	total_fun(X),
	statistics(runtime,[_,T]),
	nl, display(total_fun(X)),
	display('       Time = '),display(T),display(' ms'),nl,nl,nl.


