:- module(game_tabling_03, _).

:- use_module(library(dynamic)).
:- dynamic fun/1.

:- use_package(tabling).
:- table reach/4.

total_fun(F) :-
	assert(fun(0)),
	(
	    reach(initial, end, _, Fs),
	    fun(F1),
	    F1 < Fs,
	    retractall(fun(_)),
	    assert(fun(Fs)),
	    fail
	;
	    fun(F)
	).


reach(GameA, GameB, Tf, Ff) :-
	reach(GameA, GameZ, T1, F1),
	edge(GameZ, GameB, T2, F2),
	Ff is F1 + F2,
	Tm is T1 + T2, Tm >= 0,
	cap(Cap), (Tm > Cap -> Tf is Cap ; Tf is Tm).
reach(GameA, GameB, T, F) :-
	edge(GameA, GameB, T, F).

edge(initial,      g(1, no),     T,  0) :- cap(T).
edge(g(Game, yes), end,          0,  0) :- num_g(Game).
edge(g(Game, _),   g(Game, yes), -1, F) :- fun(Game, F).
edge(g(Game, yes), g(Game1, no), T,  0) :-
	Game1 is Game + 1, num_g(Games), Game1 =< Games,
	refill(T).


:- include(data_03).

main(_) :-
	statistics(runtime, _),
	total_fun(X),
	statistics(runtime,[_,T]),
	nl, display(total_fun(X)),
	display('       Time = '),display(T),display(' ms'),nl,nl,nl.


