

:- use_package(tclp_aggregates).

:- table minimax(_, first, best).

minimax(Pos, NextPos, (Pos,Val)) :-
	move(Pos, NextPos),
	minimax(NextPos, _, (NextPos, Val)).
minimax(Pos, Pos, (Pos,Val)) :-
	\+ move(Pos, _),
	utility(Pos,Val).


%% Aggregate definition %%
entails(best,(Pos,ValA),(Pos,ValB)) :-      % New Pos better than Previous
	min_to_move(Pos),
	ValB =< ValA.                        % MAX prefers the greater value
	
entails(best,(Pos,ValA),(Pos,ValB)) :-      % New Pos better than Previous
	max_to_move(Pos),
	ValB >= ValA.                        % MIN prefers the lesser value

entails(first,_,_) :- true.
